/// <reference types="react" />
import { KeyboardEventT } from '../../../definitions.interface';
import { IBasicEvent } from '../../../react-definitions.interface';
import { DateTimeLikeTypeT } from '../../../converter';
import { IDateFieldProps, IDateFieldState } from './datefield.interface';
import { BaseTextField } from '../textfield';
export declare class DateField<TComponent extends DateField<TComponent, TProps, TState>, TProps extends IDateFieldProps = IDateFieldProps, TState extends IDateFieldState = IDateFieldState> extends BaseTextField<TComponent, TProps, TState> {
    static defaultProps: IDateFieldProps;
    /**
     * @stable [07.01.2019]
     * @param {IDateFieldProps} props
     */
    constructor(props: TProps);
    /**
     * @stable [07.01.2018]
     * @param {DateTimeLikeTypeT} currentRawValue
     */
    onChangeManually(currentRawValue: DateTimeLikeTypeT): void;
    onKeyEnter(event: KeyboardEventT): void;
    protected getInputAttachmentElement(): JSX.Element;
    /**
     * @stable [07.01.2018]
     * @returns {Array<string | RegExp>}
     */
    protected getFieldMask(): Array<string | RegExp>;
    /**
     * @stable [07.01.2019]
     * @returns {string}
     */
    protected getFieldPattern(): string;
    /**
     * @stable [07.01.2019]
     * @returns {string}
     */
    protected getFieldFormat(): string;
    /**
     * @stable [07.01.2018]
     * @param {IBasicEvent} event
     */
    protected onClick(event: IBasicEvent): void;
    /**
     * @stable [07.01.2019]
     * @param {AnyT} value
     * @returns {string}
     */
    protected prepareValueBeforeDisplaying(value: DateTimeLikeTypeT): string;
    /**
     * @stable [20.08.2018]
     * @param {Date} date
     */
    private onAccept;
    /**
     * @stable [07.01.2019]
     * @returns {Date}
     */
    private readonly initialDialogDate;
    private readonly dialogWindow;
    private readonly dateTimeSettings;
    /**
     * @stable [07.01.2019]
     * @param {DateTimeLikeTypeT} value
     * @returns {string}
     */
    private formatDate;
    /**
     * @stable [07.01.2019]
     */
    private onCalendarClick;
}
