"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var grid_1 = require("../../grid");
var list_1 = require("../../list");
var multifield_1 = require("../multifield");
var util_1 = require("../../../util");
var GridField = /** @class */ (function (_super) {
    __extends(GridField, _super);
    /**
     * @stable [02.06.2018]
     * @param {IGridFieldProps} props
     */
    function GridField(props) {
        var _this = _super.call(this, props) || this;
        _this.onChangeRowField = _this.onChangeRowField.bind(_this);
        return _this;
    }
    /**
     * @stable [21.06.2018]
     * @returns {JSX.Element}
     */
    GridField.prototype.getAttachmentElement = function () {
        var props = this.props;
        var gridListEntity = __assign({}, list_1.INITIAL_APPLICATION_LIST_STATE, { data: this.multiFieldPlugin.activeValue, changes: multifield_1.fromMultiItemEntitiesToFieldsChanges(this.multiFieldPlugin.editValue) });
        return (React.createElement(grid_1.Grid, __assign({ emptyMessage: this.settings.messages.noItemsMessage, emptyDataMessage: this.settings.messages.noItemsMessage }, gridListEntity, props.gridConfiguration, { onChange: this.onChangeRowField, deactivated: this.isFieldDeactivated() })));
    };
    /**
     * @stable [19.09.2018]
     * @returns {string}
     */
    GridField.prototype.getFieldClassName = function () {
        return util_1.toClassName(_super.prototype.getFieldClassName.call(this), 'rac-gridfield');
    };
    /**
     * @stable [07.06.2018]
     * @param {IFieldChangeEntity} fieldChangeEntity
     */
    GridField.prototype.onChangeRowField = function (fieldChangeEntity) {
        this.multiFieldPlugin.onEditItem(__assign({ id: fieldChangeEntity.rawData.id }, fieldChangeEntity));
    };
    return GridField;
}(multifield_1.MultiField));
exports.GridField = GridField;
//# sourceMappingURL=gridfield.component.js.map