"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var field_1 = require("../../field");
var layout_1 = require("../../layout");
var viewer_1 = require("../../viewer");
var ViewField = /** @class */ (function (_super) {
    __extends(ViewField, _super);
    function ViewField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [27.06.2018]
     * @returns {JSX.Element}
     */
    ViewField.prototype.render = function () {
        return (React.createElement("div", { className: this.getFieldClassName() },
            React.createElement(layout_1.FlexLayout, { ref: 'self', className: 'rac-view-field' },
                this.getInputElement(),
                this.viewElement)));
    };
    /**
     * @stable [27.06.2018]
     * @returns {IFieldInputProps}
     */
    ViewField.prototype.getInputElementProps = function () {
        return __assign({}, _super.prototype.getInputElementProps.call(this), { type: 'hidden' });
    };
    Object.defineProperty(ViewField.prototype, "viewElement", {
        /**
         * @stable [27.06.2018]
         * @returns {JSX.Element}
         */
        get: function () {
            var Component = this.props.viewer;
            return React.createElement(Component, { src: field_1.toLastAddedMultiItemEntity(this.value) });
        },
        enumerable: true,
        configurable: true
    });
    ViewField.defaultProps = {
        viewer: viewer_1.PictureViewer,
    };
    return ViewField;
}(field_1.Field));
exports.ViewField = ViewField;
//# sourceMappingURL=viewfield.component.js.map