"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var entities_definitions_interface_1 = require("../../../entities-definitions.interface");
var util_1 = require("../../../util");
var base_column_1 = require("../base-column");
var GridHeaderColumn = /** @class */ (function (_super) {
    __extends(GridHeaderColumn, _super);
    /**
     * @stable [05.04.2018]
     * @param {IGridHeaderColumnProps} props
     */
    function GridHeaderColumn(props) {
        var _this = _super.call(this, props) || this;
        _this.onHeaderColumnClick = _this.onHeaderColumnClick.bind(_this);
        return _this;
    }
    /**
     * @stable [05.04.2018]
     * @returns {JSX.Element}
     */
    GridHeaderColumn.prototype.render = function () {
        var _this = this;
        var props = this.props;
        return util_1.orNull(props.headerRendered !== false, function () { return (React.createElement("th", { style: _this.getStyle({ width: props.headerWidth }), colSpan: util_1.nvl(props.headerColSpan, props.colSpan), className: _this.getClassName(props.useSorting && 'rac-grid-sorted-column', 'rac-no-user-select', props.headerClassName), onClick: util_1.orUndef(props.useSorting, function () { return _this.onHeaderColumnClick; }) },
            _this.getColumnContentElement(),
            util_1.orNull(props.useSorting, function () { return (_this.uiFactory.makeIcon({
                // Prevent text jumping
                className: "rac-grid-column-direction " + (R.isNil(props.direction) ? 'rac-visibility-hidden' : ''),
                type: props.direction === entities_definitions_interface_1.SortDirectionEnum.ASC
                    ? 'arrow_downward'
                    : 'arrow_upward',
            })); }))); });
    };
    /**
     * @stable - 05.04.2018
     * @param {IBasicEvent} event
     */
    GridHeaderColumn.prototype.onHeaderColumnClick = function (event) {
        util_1.cancelEvent(event);
        var props = this.props;
        if (props.onClick) {
            props.onClick({
                name: props.name,
                direction: props.direction === entities_definitions_interface_1.SortDirectionEnum.ASC
                    ? entities_definitions_interface_1.SortDirectionEnum.DESC
                    : entities_definitions_interface_1.SortDirectionEnum.ASC,
            });
        }
    };
    return GridHeaderColumn;
}(base_column_1.BaseGridColumn));
exports.GridHeaderColumn = GridHeaderColumn;
//# sourceMappingURL=grid-header-column.component.js.map