"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var inversify_1 = require("inversify");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var free_brands_svg_icons_1 = require("@fortawesome/free-brands-svg-icons");
var free_regular_svg_icons_1 = require("@fortawesome/free-regular-svg-icons");
var ts_smart_logger_1 = require("ts-smart-logger");
var util_1 = require("../../../util");
var di_1 = require("../../../di");
var UIMaterialFactory = /** @class */ (function () {
    function UIMaterialFactory() {
        this.list = 'mdc-list';
        this.switch = 'mdc-switch';
        this.switchInput = 'mdc-switch__native-control';
        this.switchInputWrapper = 'mdc-switch__thumb-underlay';
        this.switchInputWrapperBody = 'mdc-switch__thumb';
        this.snackbar = 'mdc-snackbar';
        this.snackbarText = 'mdc-snackbar__text';
        this.snackbarActionWrapper = 'mdc-snackbar__action-wrapper';
        this.snackbarActionButton = 'mdc-snackbar__action-button';
        this.icons = 'material-icons';
        this.toolbar = 'mdc-toolbar';
        this.tabBarScrollerScrollArea = 'mdc-tab-scroller__scroll-area';
        this.tabBarScrollerScrollAreaScroll = 'mdc-tab-scroller__scroll-area--scroll';
        this.tabBarScrollerScrollContent = 'mdc-tab-scroller__scroll-content';
        this.tabRipple = 'mdc-tab__ripple';
        this.tabBar = 'mdc-tab-bar';
        this.tab = 'mdc-tab';
        this.tabContent = 'mdc-tab__content';
        this.tabIcon = 'mdc-tab__icon';
        this.tabIconText = 'mdc-tab__icon-text';
        this.tabActive = 'mdc-tab--active';
        this.tabIndicator = 'mdc-tab-indicator';
        this.tabIndicatorActive = 'mdc-tab-indicator--active';
        this.tabIndicatorContent = 'mdc-tab-indicator__content';
        this.tabIndicatorContentUnderline = 'mdc-tab-indicator__content--underline';
        this.tabBarScroller = 'mdc-tab-scroller';
        this.listItemMeta = 'mdc-list-item__meta';
        this.listDivider = 'mdc-list-divider';
        this.listGroupSubHeader = 'mdc-list-group__subheader';
        this.textFieldBox = 'mdc-text-field--box';
        this.checkbox = 'mdc-checkbox';
        this.checkboxInput = 'mdc-checkbox__native-control';
        this.card = 'mdc-card';
        this.cardActions = 'mdc-card__actions';
        this.cardActionButtons = 'mdc-card__action-buttons';
        this.cardActionIcons = 'mdc-card__action-icons';
        this.rippleSurface = 'mdc-ripple-surface';
        this.menuAnchor = 'mdc-menu-surface--anchor';
        this.menuSurface = 'mdc-menu-surface';
        this.menu = 'mdc-menu';
        this.fab = 'mdc-fab';
        this.dialog = 'mdc-dialog';
        this.dialogSurface = 'mdc-dialog__surface';
        this.dialogContent = 'mdc-dialog__content';
        this.dialogContainer = 'mdc-dialog__container';
        this.dialogTitle = 'mdc-dialog__title';
        this.dialogScrim = 'mdc-dialog__scrim';
        this.dialogActions = 'mdc-dialog__actions';
    }
    UIMaterialFactory_1 = UIMaterialFactory;
    /**
     * @stable [18.05.2018]
     * @param {UniversalUIIconConfigurationT} cfg
     * @returns {JSX.Element}
     */
    UIMaterialFactory.prototype.makeIcon = function (cfg) {
        if (!cfg) {
            return null;
        }
        var config = this.toIconConfig(cfg);
        var awIconCtor = UIMaterialFactory_1.ICONS_MAP[config.type];
        if (!awIconCtor) {
            UIMaterialFactory_1.logger.warn("[$UIMaterialFactory] The icon " + config.type + " is not defined.");
        }
        var iconCtor = awIconCtor || free_solid_svg_icons_1.faQuestion;
        var isButton = util_1.isFn(config.onClick);
        return (React.createElement("div", { key: config.key || util_1.uuid(), title: this.t(config.title), className: util_1.toClassName(config.className, 'rac-flex', 'rac-flex-center', 'rac-icon', isButton && "rac-action-icon rac-button-" + config.type + "-icon", config.disabled && 'rac-disabled-icon'), onClick: function (event) {
                if (!config.disabled && isButton) {
                    config.onClick(event);
                }
            } },
            React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: iconCtor })));
    };
    /**
     * @stable [18.05.2018]
     * @param {IUIIconConfiguration | string} cfg
     * @returns {JSX.Element}
     */
    UIMaterialFactory.prototype.makeListItemMetaIcon = function (cfg) {
        var config = this.toIconConfig(cfg);
        return this.makeIcon(cfg
            ? __assign({}, config, { className: util_1.toClassName(config.className, 'rac-list-item-meta-icon') }) : cfg);
    };
    UIMaterialFactory.prototype.makeCheckboxAttachment = function () {
        return (React.createElement("div", { className: 'mdc-checkbox__background' },
            React.createElement("svg", { className: 'mdc-checkbox__checkmark', viewBox: '0 0 24 24' },
                React.createElement("path", { className: 'mdc-checkbox__checkmark-path', fill: 'none', stroke: 'white', d: 'M1.73,12.91 8.1,19.28 22.79,4.59' })),
            React.createElement("div", { className: 'mdc-checkbox__mixedmark' })));
    };
    /**
     * @stable [30.08.2018]
     * @returns {JSX.Element}
     */
    UIMaterialFactory.prototype.makeSwitchAttachment = function () {
        return React.createElement("div", { className: 'mdc-switch__track' });
    };
    /**
     * @stable [18.05.2018]
     * @param {UniversalUIIconConfigurationT} cfg
     * @returns {IUIIconConfiguration}
     */
    UIMaterialFactory.prototype.toIconConfig = function (cfg) {
        return (util_1.isString(cfg) ? { type: cfg } : cfg);
    };
    var UIMaterialFactory_1;
    UIMaterialFactory.ICONS_MAP = {
        access_time: free_solid_svg_icons_1.faHistory,
        add: free_solid_svg_icons_1.faPlus,
        address_card: free_regular_svg_icons_1.faAddressCard,
        adversal: free_brands_svg_icons_1.faAdversal,
        arrow_alt_circle_down: free_solid_svg_icons_1.faArrowAltCircleDown,
        arrow_alt_circle_right: free_solid_svg_icons_1.faArrowAltCircleRight,
        arrow_alt_circle_right_regular: free_regular_svg_icons_1.faArrowAltCircleRight,
        arrow_alt_circle_up: free_solid_svg_icons_1.faArrowAltCircleUp,
        arrow_alt_circle_up_regular: free_regular_svg_icons_1.faArrowAltCircleUp,
        arrow_down: free_solid_svg_icons_1.faArrowDown,
        arrow_left: free_solid_svg_icons_1.faArrowLeft,
        arrow_right: free_solid_svg_icons_1.faArrowRight,
        arrow_up: free_solid_svg_icons_1.faArrowUp,
        arrows_alt_h: free_solid_svg_icons_1.faArrowsAltH,
        attach_file: free_solid_svg_icons_1.faPaperclip,
        attention: free_solid_svg_icons_1.faExclamationCircle,
        backward: free_regular_svg_icons_1.faArrowAltCircleLeft,
        ban: free_solid_svg_icons_1.faBan,
        barcode: free_solid_svg_icons_1.faBarcode,
        binoculars: free_solid_svg_icons_1.faBinoculars,
        block: free_solid_svg_icons_1.faBan,
        calendar_alt: free_regular_svg_icons_1.faCalendarAlt,
        card_giftcard: free_solid_svg_icons_1.faGift,
        category: free_brands_svg_icons_1.faCodepen,
        chart_pie: free_solid_svg_icons_1.faChartPie,
        check: free_solid_svg_icons_1.faCheck,
        check_circle: free_solid_svg_icons_1.faCheckCircle,
        check_circle_regular: free_regular_svg_icons_1.faCheckCircle,
        chevron_down: free_solid_svg_icons_1.faChevronDown,
        chevron_up: free_solid_svg_icons_1.faChevronUp,
        clear: free_solid_svg_icons_1.faTimes,
        clear_all: free_solid_svg_icons_1.faEraser,
        clock_regular: free_regular_svg_icons_1.faClock,
        close: free_solid_svg_icons_1.faTimes,
        cloud: free_solid_svg_icons_1.faCloud,
        cloud_download: free_solid_svg_icons_1.faFileDownload,
        comment_regular: free_regular_svg_icons_1.faComment,
        comments_regular: free_regular_svg_icons_1.faComments,
        contact_mail: free_regular_svg_icons_1.faEnvelope,
        contact_phone: free_solid_svg_icons_1.faPhone,
        dashboard: free_solid_svg_icons_1.faChartLine,
        dollar_sign: free_solid_svg_icons_1.faDollarSign,
        done: free_solid_svg_icons_1.faCheck,
        done_all: free_solid_svg_icons_1.faCheckDouble,
        down: free_solid_svg_icons_1.faArrowAltCircleDown,
        edit: free_solid_svg_icons_1.faPen,
        error: free_solid_svg_icons_1.faExclamationCircle,
        error_outline: free_solid_svg_icons_1.faExclamation,
        exchange: free_solid_svg_icons_1.faExchangeAlt,
        exchange_alt: free_solid_svg_icons_1.faExchangeAlt,
        exclamation_circle: free_solid_svg_icons_1.faExclamationCircle,
        exclamation_triangle: free_solid_svg_icons_1.faExclamationTriangle,
        expand_more: free_solid_svg_icons_1.faChevronDown,
        eye: free_solid_svg_icons_1.faEye,
        fa_heart_regular: free_regular_svg_icons_1.faHeart,
        file: free_regular_svg_icons_1.faFileAlt,
        file_export: free_solid_svg_icons_1.faFileExport,
        file_import: free_solid_svg_icons_1.faFileImport,
        file_invoice_dollar: free_solid_svg_icons_1.faFileInvoiceDollar,
        filter_list: free_solid_svg_icons_1.faFilter,
        first_page: free_solid_svg_icons_1.faAngleDoubleLeft,
        format_list_numbered: free_solid_svg_icons_1.faListOl,
        gift: free_solid_svg_icons_1.faGift,
        group: free_solid_svg_icons_1.faUsers,
        hdd: free_regular_svg_icons_1.faHdd,
        help_outline: free_regular_svg_icons_1.faQuestionCircle,
        history: free_solid_svg_icons_1.faHistory,
        home: free_solid_svg_icons_1.faHome,
        houzz: free_brands_svg_icons_1.faHouzz,
        http: free_solid_svg_icons_1.faExchangeAlt,
        id_card: free_regular_svg_icons_1.faIdCard,
        info: free_solid_svg_icons_1.faInfo,
        key: free_solid_svg_icons_1.faKey,
        keyboard_arrow_left: free_solid_svg_icons_1.faAngleLeft,
        keyboard_arrow_right: free_solid_svg_icons_1.faAngleRight,
        last_page: free_solid_svg_icons_1.faAngleDoubleRight,
        level_down_alt: free_solid_svg_icons_1.faLevelDownAlt,
        list_ul: free_solid_svg_icons_1.faListUl,
        local_atm: free_solid_svg_icons_1.faMoneyBill,
        local_offer: free_solid_svg_icons_1.faTag,
        location: free_solid_svg_icons_1.faMapMarkerAlt,
        location_on: free_solid_svg_icons_1.faMapMarkerAlt,
        lock: free_solid_svg_icons_1.faLock,
        lock_open: free_solid_svg_icons_1.faUnlockAlt,
        long_arrow_alt_down: free_solid_svg_icons_1.faLongArrowAltDown,
        long_arrow_alt_left: free_solid_svg_icons_1.faLongArrowAltLeft,
        long_arrow_alt_right: free_solid_svg_icons_1.faLongArrowAltRight,
        long_arrow_alt_up: free_solid_svg_icons_1.faLongArrowAltUp,
        loyalty: free_brands_svg_icons_1.faGratipay,
        map_marked_alt: free_solid_svg_icons_1.faMapMarkedAlt,
        map_marker_alt: free_solid_svg_icons_1.faMapMarkerAlt,
        menu: free_solid_svg_icons_1.faBars,
        minus: free_solid_svg_icons_1.faMinus,
        minus_circle: free_solid_svg_icons_1.faMinusCircle,
        minus_square: free_regular_svg_icons_1.faMinusSquare,
        more_hor: free_solid_svg_icons_1.faEllipsisH,
        more_vert: free_solid_svg_icons_1.faEllipsisV,
        navigate_before: free_solid_svg_icons_1.faChevronLeft,
        navigate_next: free_solid_svg_icons_1.faChevronRight,
        object_group_regular: free_regular_svg_icons_1.faObjectGroup,
        payment: free_regular_svg_icons_1.faCreditCard,
        pen: free_solid_svg_icons_1.faPen,
        people_carry: free_solid_svg_icons_1.faPeopleCarry,
        people_outline: free_regular_svg_icons_1.faUser,
        percent: free_solid_svg_icons_1.faPercent,
        person: free_solid_svg_icons_1.faUser,
        person_outline: free_regular_svg_icons_1.faUser,
        phone: free_solid_svg_icons_1.faPhone,
        play_circle_regular: free_regular_svg_icons_1.faPlayCircle,
        playlist_add_check: free_solid_svg_icons_1.faClipboardCheck,
        plug: free_solid_svg_icons_1.faPlug,
        plus: free_solid_svg_icons_1.faPlus,
        plus_square: free_regular_svg_icons_1.faPlusSquare,
        power_off: free_solid_svg_icons_1.faPowerOff,
        print: free_solid_svg_icons_1.faPrint,
        priority_high: free_solid_svg_icons_1.faExclamation,
        product: free_solid_svg_icons_1.faCannabis,
        question: free_solid_svg_icons_1.faQuestion,
        refresh: free_solid_svg_icons_1.faSync,
        remove: free_solid_svg_icons_1.faMinus,
        retweet: free_solid_svg_icons_1.faRetweet,
        router: free_solid_svg_icons_1.faServer,
        save: free_regular_svg_icons_1.faSave,
        search: free_solid_svg_icons_1.faSearch,
        search_plus: free_solid_svg_icons_1.faSearchPlus,
        shield_alt: free_solid_svg_icons_1.faShieldAlt,
        shipping_fast: free_solid_svg_icons_1.faShippingFast,
        shopping_basket: free_solid_svg_icons_1.faShoppingBasket,
        shopping_cart: free_solid_svg_icons_1.faShoppingCart,
        sign_out_alt: free_solid_svg_icons_1.faSignOutAlt,
        signIn: free_solid_svg_icons_1.faSignInAlt,
        smile_beam: free_regular_svg_icons_1.faSmileBeam,
        sms: free_solid_svg_icons_1.faCommentDots,
        spa: free_solid_svg_icons_1.faCannabis,
        spinner: free_solid_svg_icons_1.faSpinner,
        stop: free_solid_svg_icons_1.faStop,
        stop_circle: free_regular_svg_icons_1.faStopCircle,
        stop_circle_regular: free_regular_svg_icons_1.faStopCircle,
        store_alt: free_solid_svg_icons_1.faStoreAlt,
        tablet: free_solid_svg_icons_1.faTabletAlt,
        taxi: free_solid_svg_icons_1.faTaxi,
        thumbs_up: free_regular_svg_icons_1.faThumbsUp,
        timelapse: free_solid_svg_icons_1.faSpinner,
        times: free_solid_svg_icons_1.faTimes,
        times_circle: free_solid_svg_icons_1.faTimesCircle,
        trash: free_regular_svg_icons_1.faTrashAlt,
        truck: free_solid_svg_icons_1.faTruck,
        truck_moving: free_solid_svg_icons_1.faTruckMoving,
        undo: free_solid_svg_icons_1.faUndo,
        user: free_regular_svg_icons_1.faUser,
        user_circle: free_regular_svg_icons_1.faUserCircle,
        user_clock: free_solid_svg_icons_1.faUserClock,
        user_edit: free_solid_svg_icons_1.faUserEdit,
        user_plus: free_solid_svg_icons_1.faUserPlus,
        user_regular: free_regular_svg_icons_1.faUser,
        user_shield: free_solid_svg_icons_1.faUserShield,
        user_tie: free_solid_svg_icons_1.faUserTie,
        verified_user: free_solid_svg_icons_1.faShieldAlt,
        video: free_solid_svg_icons_1.faVideo,
        warehouse: free_solid_svg_icons_1.faWarehouse,
        warning: free_solid_svg_icons_1.faExclamationTriangle,
        widgets: free_solid_svg_icons_1.faCubes,
        work: free_solid_svg_icons_1.faBriefcase,
    };
    UIMaterialFactory.logger = ts_smart_logger_1.LoggerFactory.makeLogger('UIMaterialFactory');
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Translate),
        __metadata("design:type", Function)
    ], UIMaterialFactory.prototype, "t", void 0);
    UIMaterialFactory = UIMaterialFactory_1 = __decorate([
        inversify_1.injectable()
    ], UIMaterialFactory);
    return UIMaterialFactory;
}());
exports.UIMaterialFactory = UIMaterialFactory;
//# sourceMappingURL=ui-material.factory.js.map