"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var di_module_1 = require("./di.module");
/**
 * @stable [26.04.2018]
 * @param {interfaces.ServiceIdentifier<T>} serviceIdentifier
 * @returns {any}
 */
exports.staticInjector = function (serviceIdentifier) {
    return di_module_1.appContainer.get(serviceIdentifier);
};
/**
 * @stable [26.04.2018]
 * @param target
 * @returns {(target: any) => any}
 */
exports.provideInSingleton = function (target) { return di_module_1.provideInSingletonDecorator(target)
    .inSingletonScope()
    .done(true); };
/**
 * @stable [26.04.2018]
 * @param {interfaces.ServiceIdentifier<T> | {new(...args: AnyT[]): T}} contract
 * @param {{new(...args: AnyT[]): T}} implementation
 * @returns {interfaces.BindingWhenOnSyntax<any>}
 */
exports.bindInSingleton = function (contract, implementation) {
    return di_module_1.appContainer.bind(contract).to(implementation || contract).inSingletonScope();
};
/**
 * @stable [26.04.2018]
 * @param {interfaces.ServiceIdentifier<T> | {new(...args: AnyT[]): T}} contract
 * @param {{new(...args: AnyT[]): T}} implementation
 * @returns {interfaces.BindingWhenOnSyntax<any>}
 */
exports.rebindInSingleton = function (contract, implementation) {
    return di_module_1.appContainer.rebind(contract).to(implementation || contract).inSingletonScope();
};
//# sourceMappingURL=di.support.js.map