/// <reference types="googlemaps" />
import * as Promise from 'bluebird';
import { IGeoCoder } from './geocoder.interface';
export declare class GeoCoder implements IGeoCoder {
    private geocoder;
    /**
     * @stable [30.07.2018]
     * @param {google.maps.GeocoderRequest} request
     * @returns {Bluebird<google.maps.GeocoderResult[]>}
     */
    geocode(request: google.maps.GeocoderRequest): Promise<google.maps.GeocoderResult[]>;
    /**
     * @stable [30.07.2018]
     * @returns {Bluebird<void>}
     */
    private getScriptPromise;
    /**
     * @stable [30.07.2018]
     */
    private initGoogleMapsObjects;
}
