import { ApplicationStorageTypeEnum, IApplicationStorage } from '../storage';
import { AnyT } from '../definitions.interface';
import { IApplicationSettings } from '../settings';
export declare class Storage implements IApplicationStorage {
    private prefix;
    private settingsResolver;
    private storageType?;
    constructor(prefix: string, settingsResolver: () => IApplicationSettings, storageType?: ApplicationStorageTypeEnum);
    enabled: boolean;
    disabled: boolean;
    set(key: string, value: AnyT): Promise<boolean>;
    get(key: string): Promise<AnyT>;
    remove(key: string, noPrefix?: boolean): Promise<boolean>;
    each(command: (key: string, value: AnyT) => void): void;
    private readonly storage;
    private toKey;
}
