"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var redux_effects_promise_1 = require("redux-effects-promise");
var di_1 = require("../../di");
var middleware_1 = require("../middleware");
var action_builder_1 = require("../../component/action.builder");
/**
 * @stable [02.06.2018]
 */
function makeFormFilterEffectsProxy(config) {
    var formFilterSubmitMiddleware = middleware_1.makeFormFilterSubmitMiddleware(config);
    var formFilterResetMiddleware = middleware_1.makeFormFilterResetMiddleware(config);
    var formFilterClearMiddleware = middleware_1.makeFormFilterClearMiddleware(config);
    return function () {
        var Effects = /** @class */ (function () {
            function Effects() {
            }
            Effects_1 = Effects;
            /**
             * Manual clear of a single filter field to provoke a reload.
             *
             * @stable [26.08.2018]
             * @returns {IEffectsAction[]}
             */
            Effects.prototype.$onFilterClear = function () {
                return formFilterClearMiddleware;
            };
            Effects.prototype.$onFilterSubmit = function () {
                return formFilterSubmitMiddleware;
            };
            Effects.prototype.$onFilterReset = function () {
                return formFilterResetMiddleware;
            };
            var Effects_1;
            __decorate([
                redux_effects_promise_1.EffectsService.effects(action_builder_1.FormActionBuilder.buildClearActionType(config.filterSection)),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Object)
            ], Effects.prototype, "$onFilterClear", null);
            __decorate([
                redux_effects_promise_1.EffectsService.effects(action_builder_1.FormActionBuilder.buildSubmitActionType(config.filterSection)),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Array)
            ], Effects.prototype, "$onFilterSubmit", null);
            __decorate([
                redux_effects_promise_1.EffectsService.effects(action_builder_1.FormActionBuilder.buildResetActionType(config.filterSection)),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Array)
            ], Effects.prototype, "$onFilterReset", null);
            Effects = Effects_1 = __decorate([
                di_1.provideInSingleton(Effects_1)
            ], Effects);
            return Effects;
        }());
    };
}
exports.makeFormFilterEffectsProxy = makeFormFilterEffectsProxy;
//# sourceMappingURL=form-filter-effects.proxy.js.map